declare enum Currency {
    Naira = "NGN",
    Dollar = "USD"
}

type CreateWalletInput = {
    username: string;
    password: string;
};
type GetBalanceInput = {
    address: string;
};
type DepositFundsInput = {
    userAddress: string;
    username: string;
    amount: string;
    currency: Currency;
    admin: string;
    adminpwd: string;
};

declare const getBalance: ({ address }: GetBalanceInput) => Promise<{
    ngnBalance: any;
    usdBalance: any;
    toroGBalance: any;
}>;

type SetNameInput = {
    address: string;
    password: string;
    username: string;
};

declare const createWallet: ({ password, username }: CreateWalletInput) => Promise<string>;
declare const configureTNS: ({ address, password, username }: SetNameInput) => Promise<void>;

declare const depositFunds: ({ userAddress, username, amount, currency, admin, adminpwd, }: DepositFundsInput) => Promise<any>;
declare const confirmDeposit: ({ currency, transactionId, }: {
    currency: string;
    transactionId: string;
}) => Promise<any>;

export { Currency, configureTNS, confirmDeposit, createWallet, depositFunds, getBalance };
