"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/index.ts
var index_exports = {};
__export(index_exports, {
  Currency: () => Currency,
  configureTNS: () => configureTNS,
  confirmDeposit: () => confirmDeposit,
  createWallet: () => createWallet,
  depositFunds: () => depositFunds,
  getBalance: () => getBalance
});
module.exports = __toCommonJS(index_exports);

// src/api/account.ts
var import_axios = __toESM(require("axios"));

// src/api/config.ts
var BASE_URL = "https://www.toronet.org";

// src/api/account.ts
var createKeystore = (_0) => __async(void 0, [_0], function* ({
  password
}) {
  const url = `${BASE_URL}/api/keystore`;
  const data = {
    op: "createkey",
    params: [{ name: "pwd", value: password }]
  };
  const response = yield import_axios.default.post(url, data);
  return response.data.address;
});
var isNameUsed = (name) => __async(void 0, null, function* () {
  const url = `${BASE_URL}/api/tns`;
  const data = {
    op: "isnameused",
    params: [{ name: "name", value: name }]
  };
  const config = {
    method: "GET",
    url,
    headers: {
      "Content-Type": "application/json"
    },
    data
  };
  const response = yield (0, import_axios.default)(config);
  console.dir(response.data, { depth: null });
  return response.data.isused;
});
var setName = (_0) => __async(void 0, [_0], function* ({ address, password, username }) {
  const url = `${BASE_URL}/api/tns/cl`;
  const data = {
    op: "setname",
    params: [
      { name: "client", value: address },
      { name: "clientpwd", value: password },
      { name: "name", value: username }
    ]
  };
  const response = yield import_axios.default.post(url, data);
  console.dir(response.data, { depth: null });
});

// src/api/balance.ts
var import_axios2 = __toESM(require("axios"));
var getAddressBalance = (_0) => __async(void 0, [_0], function* ({ address }) {
  const url = `${BASE_URL}/api/query`;
  const data = {
    op: "getaddrbalance",
    params: [{ name: "addr", value: address }]
  };
  const config = {
    method: "get",
    url,
    headers: {
      "Content-Type": "application/json"
    },
    data
  };
  const response = yield (0, import_axios2.default)(config);
  console.dir(response.data, { depth: null });
  return {
    ngnBalance: response.data.bal_naira,
    usdBalance: response.data.bal_dollar,
    toroGBalance: response.data.bal_auth
  };
});

// src/utils/address_validator.ts
var validateEvmAddress = (address) => {
  const isValidLength = address.length === 42;
  const hasValidPrefix = address.startsWith("0x");
  const isHexadecimal = /^[0-9a-fA-F]+$/.test(address.slice(2));
  return isValidLength && hasValidPrefix && isHexadecimal;
};

// src/services/balance_service.ts
var getBalance = (_0) => __async(void 0, [_0], function* ({ address }) {
  if (!address) {
    throw new Error("Address is required");
  }
  if (validateEvmAddress(address) === false) {
    throw new Error("Invalid Toronet address");
  }
  const balanceInput = {
    address
  };
  return yield getAddressBalance(balanceInput);
});

// src/services/wallet_service.ts
var createWallet = (_0) => __async(void 0, [_0], function* ({ password, username }) {
  if (!password || !username) {
    throw new Error("Username and Password is required");
  }
  const keystoreInput = {
    password
  };
  const isTNSUsed = yield isNameUsed(username);
  if (isTNSUsed) {
    throw new Error("Username is already taken");
  }
  const address = yield createKeystore(keystoreInput);
  yield configureTNS({ address, password, username });
  return address;
});
var configureTNS = (_0) => __async(void 0, [_0], function* ({ address, password, username }) {
  if (!address || !password || !username) {
    throw new Error("Address, password, and username are required");
  }
  const setNameInput = {
    address,
    password,
    username
  };
  yield setName(setNameInput);
});

// src/api/payments.ts
var import_axios3 = __toESM(require("axios"));
var initializeDeposit = (_0) => __async(void 0, [_0], function* ({
  usrAddr,
  username,
  amount,
  currency,
  admin,
  adminpwd
}) {
  var _a, _b;
  const url = `${BASE_URL}/api/payment/toro/`;
  const data = {
    op: "paymentinitialize",
    params: [
      { name: "currency", value: currency },
      // USD or NGN
      { name: "token", value: currency },
      { name: "address", value: usrAddr },
      { name: "amount", value: amount },
      { name: "success_url", value: "https://yourweb.com/pmt/done?" },
      { name: "cancel_url", value: "https://toronet.org/cancel" },
      { name: "paymenttype", value: currency === "USD" ? "card" : "bank" },
      { name: "feetype", value: "1" },
      { name: "exchange", value: "72" },
      { name: "reusewallet", value: "0" },
      { name: "payername", value: username },
      { name: "payeraddress", value: "11 Olaoye Close" },
      { name: "payercity", value: "Lagos" },
      { name: "payerstate", value: "" },
      { name: "payercountry", value: "" },
      { name: "payerzipcode", value: "" },
      { name: "payerphone", value: "" },
      { name: "description", value: "Deposit" }
    ]
  };
  const config = {
    headers: {
      adminpwd,
      admin
    }
  };
  try {
    const response = yield import_axios3.default.post(url, data, config);
    console.dir(response.data, { depth: null });
    if (!response.data.result) throw new Error(response.data.error);
    return response.data;
  } catch (error) {
    console.error("Error:", ((_a = error.response) == null ? void 0 : _a.data) || error.message);
    throw new Error(((_b = error.response) == null ? void 0 : _b.data) || error.message);
  }
});
var verifyDeposit = (currency, txid) => __async(void 0, null, function* () {
  var _a, _b;
  const url = `${BASE_URL}/api/payment/toro/`;
  const data = {
    op: "recordfiattransaction",
    params: [
      { name: "currency", value: currency },
      { name: "txid", value: txid },
      { name: "paymenttype", value: currency === "USD" ? "card" : "bank" }
    ]
  };
  try {
    const response = yield import_axios3.default.post(url, data);
    console.log("Verify Deposit Response:", response.data);
    if (!response.data.result) throw new Error(response.data.error);
    return response.data.result;
  } catch (error) {
    console.error("Error:", ((_a = error.response) == null ? void 0 : _a.data) || error.message);
    throw new Error(((_b = error.response) == null ? void 0 : _b.data) || error.message);
  }
});

// src/services/payments_service.ts
var depositFunds = (_0) => __async(void 0, [_0], function* ({
  userAddress,
  username,
  amount,
  currency,
  admin,
  adminpwd
}) {
  console.log(`\u{1F680} Initiating deposit: ${amount} ${currency} for ${username}`);
  if (!admin || !adminpwd) {
    throw new Error(
      "\u274C Missing admin credentials. You must register at https://payments.connectw.com/"
    );
  }
  const depositInitializationInput = {
    usrAddr: userAddress,
    username,
    amount,
    currency: currency.toString(),
    admin,
    adminpwd
  };
  const depositDetails = yield initializeDeposit(depositInitializationInput);
  return depositDetails;
});
var confirmDeposit = (_0) => __async(void 0, [_0], function* ({
  currency,
  transactionId
}) {
  console.log(`\u{1F50D} Verifying deposit with TXID: ${transactionId}`);
  const isVerified = yield verifyDeposit(currency, transactionId);
  if (isVerified) {
    console.log("\u2705 Deposit verified! Funds credited to your wallet.");
  } else {
    console.log(
      "\u26A0\uFE0F Deposit verification failed. Please check your transaction."
    );
  }
  return isVerified;
});

// src/types/currency.ts
var Currency = /* @__PURE__ */ ((Currency2) => {
  Currency2["Naira"] = "NGN";
  Currency2["Dollar"] = "USD";
  return Currency2;
})(Currency || {});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Currency,
  configureTNS,
  confirmDeposit,
  createWallet,
  depositFunds,
  getBalance
});
